
<?php

session_start();

?>
<!doctype html>
<html lang="en" >

<head>

    <meta charset="utf-8" />
    <title>Customers</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta content="Customers" name="description" />
    <!-- App favicon -->
    <link rel="shortcut icon" href="assets/images/favicon.ico">

    <!-- DataTables -->
    <link href="assets/libs/datatables.net-bs4/css/dataTables.bootstrap4.min.css" rel="stylesheet" type="text/css" />
    <link href="assets/libs/datatables.net-buttons-bs4/css/buttons.bootstrap4.min.css" rel="stylesheet"
        type="text/css" />

    <!-- Responsive datatable examples -->
    <link href="assets/libs/datatables.net-responsive-bs4/css/responsive.bootstrap4.min.css" rel="stylesheet"
        type="text/css" />

    <!-- Bootstrap Css -->
    <link href="assets/css/bootstrap.min.css" id="bootstrap-style" rel="stylesheet" type="text/css" />
    <!-- Icons Css -->
    <link href="assets/css/icons.min.css" rel="stylesheet" type="text/css" />
    <!-- App Css-->
    <link href="assets/css/app.min.css"  id="app-style"  rel="stylesheet" type="text/css" />

</head>

<body data-layout="detached" data-topbar="colored">






    <!-- <body data-layout="horizontal" data-topbar="dark"> -->

<div class="container-fluid">
    <!-- Begin page -->
    <div id="layout-wrapper">

    <?php include "header.php";?>
    <?php include "vertical-menu.php";?>
    
<!-- Left Sidebar End -->

        <!-- ============================================================== -->
        <!-- Start right Content here -->
        <!-- ============================================================== -->
        <div class="main-content">

            <div class="page-content">

                <!-- start page title -->
                <div class="row">
                    <div class="col-12">
                        <div class="page-title-box d-flex align-items-center justify-content-between">
                            <h4 class="page-title mb-0 font-size-18">Customers</h4>

                            <div class="page-title-right">
                                <ol class="breadcrumb m-0">
                                    <li class="breadcrumb-item"><a href="javascript: void(0);">Home</a></li>
                                    <li class="breadcrumb-item active">Customers</li>
                                </ol>
                            </div>

                        </div>
                    </div>
                </div>
                <!-- end page title -->

                <div class="row">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-body">

                                <!--<h4 class="card-title">Default Datatable</h4>-->
                                <!--<p class="card-title-desc">DataTables has most features enabled by default, so all-->
                                <!--    you need to do to use it with your own tables is to call the construction-->
                                <!--    function: <code>$().DataTable();</code>.-->
                                <!--</p>-->
<?php


// Shopify API credentials
$shopify_api_key = 'de3fc491950c9ec37fb37a897ba2affe';
$shopify_api_secret = 'd03965e268f378d42a369924756f6448';
$shopify_store_url = 'da91d8.myshopify.com';
$shopify_access_token = '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';

// Endpoint URL for retrieving customers
$endpoint = "https://$shopify_store_url/admin/api/2021-10/customers.json";

// Setup cURL session
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $endpoint);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', "X-Shopify-Access-Token: $shopify_access_token"));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

// Execute cURL session
$response = curl_exec($ch);
$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);


?>

                                <table id="datatable" class="table table-bordered dt-responsive nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Customer ID</th>
                                            <th>Email</th>
                                            <th>First name</th>
                                            <th>Last name</th>
                                        </tr>
                                    </thead>

                                    <tbody>
<?php

// Check if request was successful
if ($http_code == 200) {
    // Decode JSON response
    $customers = json_decode($response, true);
    
    // Loop through each customer
    foreach ($customers['customers'] as $customer) {
        // Extract relevant customer information
        $customer_id = $customer['id'];
        $customer_email = $customer['email'];
        $customer_first_name = $customer['first_name'];
        $customer_last_name = $customer['last_name'];
        
        // Output customer details
        // echo "Customer ID: $customer_id, Email: $customer_email, Name: $customer_first_name $customer_last_name <br>";
        echo "<tr>";
        echo "<td>".$customer_id."</td>";
        echo "<td>".$customer_email."</td>";
        echo "<td>".$customer_first_name."</td>";
        echo "<td>".$customer_last_name."</td>";
                echo "</tr>";

    }
} else {
    // Display error message
    echo "Error: Unable to retrieve customers. HTTP Code: $http_code <br>";
}

// Close cURL session
curl_close($ch);

?>
                                            
                                            
                                            
                                            
                                            
                                    </tbody>
                                </table>

                            </div>
                        </div>
                    </div>
                    <!-- end col -->
                </div>
                <!-- end row -->

                <!-- end row -->

            </div>
            <!-- End Page-content -->

            <footer class="footer">
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-sm-6">
                        </div>
                        <div class="col-sm-6">
                            <div class="text-sm-end d-none d-sm-block">
                            </div>
                        </div>
                    </div>
                </div>
            </footer>
        </div>
        <!-- end main content-->

    </div>
    <!-- END layout-wrapper -->

</div>
<!-- end container-fluid -->

<!-- Right Sidebar -->



<!-- /Right-bar -->

<!-- Right bar overlay-->
<div class="rightbar-overlay"></div>

<!-- JAVASCRIPT -->
<!-- JAVASCRIPT -->
<script src="assets/libs/jquery/jquery.min.js"></script>
<script src="assets/libs/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="assets/libs/metismenu/metisMenu.min.js"></script>
<script src="assets/libs/simplebar/simplebar.min.js"></script>
<script src="assets/libs/node-waves/waves.min.js"></script>
<script src="assets/libs/jquery-sparkline/jquery.sparkline.min.js"></script>

<!-- Required datatable js -->
<script src="assets/libs/datatables.net/js/jquery.dataTables.min.js"></script>
<script src="assets/libs/datatables.net-bs4/js/dataTables.bootstrap4.min.js"></script>
<!-- Buttons examples -->
<script src="assets/libs/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
<script src="assets/libs/datatables.net-buttons-bs4/js/buttons.bootstrap4.min.js"></script>
<script src="assets/libs/jszip/jszip.min.js"></script>
<script src="assets/libs/pdfmake/build/pdfmake.min.js"></script>
<script src="assets/libs/pdfmake/build/vfs_fonts.js"></script>
<script src="assets/libs/datatables.net-buttons/js/buttons.html5.min.js"></script>
<script src="assets/libs/datatables.net-buttons/js/buttons.print.min.js"></script>
<script src="assets/libs/datatables.net-buttons/js/buttons.colVis.min.js"></script>
<!-- Responsive examples -->
<script src="assets/libs/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
<script src="assets/libs/datatables.net-responsive-bs4/js/responsive.bootstrap4.min.js"></script>

<!-- Datatable init js -->
<script src="assets/js/pages/datatables.init.js"></script>

<!-- App js -->
<script src="assets/js/app.js"></script>

</body>

</html>